unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,inifiles,
  Dialogs, StdCtrls, Math, idwisaacasm, bigmath, privatekey, publickey,
  ScktComp, shellapi, syncobjs,DCPrijndael, DCPsha256, ExtCtrls, ComCtrls, Buttons,
  antikeyloggeredit, ScktComp2, AudioIO, senderthread,receiverthread,
  decompressionthread,launchthreads,generic;

type

   typesample = smallint;  // a PCM sample is a 16 bit unsigned int
   psample = ^typesample;

  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    txtKeyListenPort: TEdit;
    btnListen: TButton;
    btnConnect: TButton;
    txtKeyRemotePort: TEdit;
    txtRSAKeySize: TEdit;
    btnDisconnect: TButton;
    KeyExchangeClientSocket: TClientSocket;
    KeyExchangeServerSocket: TServerSocket;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Panel3: TPanel;
    Memo1: TMemo;
    sbListen: TSpeedButton;
    sbLaunchMoveAction: TSpeedButton;
    sbVisitWebSite: TSpeedButton;
    sbConnect: TSpeedButton;
    sbDisconnect: TSpeedButton;
    SpeedButton1: TSpeedButton;
    txtRemoteHost: TAntiKeyLoggerEdit;
    Panel4: TPanel;
    Image2: TImage;
    AudioServerSocket: TServerSocket;
    AudioClientSocket: TClientSocket;
    txtAudioListenPort: TEdit;
    Label4: TLabel;
    txtAudioRemotePort: TEdit;
    Label6: TLabel;
    Image1: TImage;
    Label7: TLabel;
    Label8: TLabel;
    cbMode: TComboBox;
    Label9: TLabel;
    Panel5: TPanel;
    SpeedButton20: TSpeedButton;
    procedure cleanupMemory;
    procedure btnListenClick(Sender: TObject);
    procedure btnConnectClick(Sender: TObject);
    procedure KeyExchangeServerSocketAccept(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure KeyExchangeClientSocketConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure KeyExchangeServerSocketClientRead(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure KeyExchangeClientSocketRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure KeyExchangeServerSocketListen(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure KeyExchangeServerSocketClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure KeyExchangeServerSocketClientError(Sender: TObject;
      Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
      var ErrorCode: Integer);
    procedure FormCreate(Sender: TObject);
    procedure FixControls;
    procedure KeyExchangeClientSocketDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure KeyExchangeClientSocketError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure btnDisconnectClick(Sender: TObject);
    procedure doClientHandshaking(textblock: string);
    procedure doServerHandshaking(textblock: string);
    function encryptWithAES(plaintext: string): string;
    function decryptWithAES(ciphertext: string): string;
    procedure sendTextToPeer(text: string);
    procedure sendTextToPeerEncrypted(plaintext: string);
    procedure handleReceivedText(receivedText: string);
    procedure handleReceivedCiphertext(ciphertext: string);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    function LPad(s: String; nLength: integer): string ;
    procedure FormShow(Sender: TObject);
    function genGarbageString(chars: integer):string;
    procedure sbLaunchMoveActionClick(Sender: TObject);
    procedure sbVisitWebSiteClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure flashTaskBar;
    procedure stopAudio;
    procedure AudioServerSocketClientRead(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure AudioServerSocketListen(Sender: TObject; Socket: TCustomWinSocket);
    procedure AudioServerSocketClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure AudioServerSocketClientError(Sender: TObject;
      Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
      var ErrorCode: Integer);
    procedure AudioClientSocketConnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure AudioClientSocketDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure AudioClientSocketError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure AudioServerSocketClientConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure AudioServerSocketAccept(Sender: TObject; Socket: TCustomWinSocket);
    procedure disconnect;
    procedure openAudioSockets;
    procedure display(msg: string);
    procedure displayAndlogToFile(msg: string);
    function findMaxSample16Bit(Buffer: PChar; Size: Integer): integer;
    function findMaxSample8Bit(Buffer: PChar; Size: Integer): integer;
    procedure drawGraph(image: TImage; x: integer; maxThisBuffer: integer);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    sendCipher,receiveCipher: TDCP_rijndael;
    isServer, handshaking, showGraphs: boolean;
    saveHost: boolean;
    moveactionPath: string;
    threadLock: TCriticalSection;
    N, E: TBigInt;
    priv: TPrivateKey;
    remotePub: TPublicKey;
    AESKey: string;
    intsInAESKey, intsInAESKeyReceived: integer;
    keyList: TStringList;
    receivedData: string;
    sendSeq, receiveSeq: integer;
    AudioIn: TAudioIn;
    AudioOut : TAudioOut;
    SenderThread: TSenderThread;
    ReceiverThread: TReceiverThread;
    DecompressionThread: TDecompressionThread;
    outputStream : TWinSocketStream;
    buffersReadOut, buffersReadIn: integer;
    clientSocketClosing, serverSocketClosing: boolean;
    remoteHostAddress: string;
  public
    { Public declarations }
    function AudioInBufferFilled(Buffer: pchar;var Size: integer): boolean;
    function AudioOutFillBuffer(Buffer: PChar; var Size: Integer): Boolean;
  end;


const
   outputZeroSoundPressure8bit = 128; // TAudio.hlp says it's 128 but it seems to be 120 on some machines
   stereo = false;
   bit16Sound = false;
   confFileName = 'cryptospeak.conf';
   ack = '**ACK**';
   char_sep = '?';

var
  Form1: TForm1;
  showStatus,connected: boolean;
  sleepDuringTransfer: integer;


implementation

{$R *.dfm}


{called by TAudioIn when it has read a chunk of bytes from the microphone}
function TForm1.AudioInBufferFilled(Buffer: pchar; var Size: integer): boolean;
var
   maxThisBuffer: integer;
begin
   // find the max sample in this buffer
   if bit16Sound then
      maxThisBuffer := findMaxSample16Bit(buffer, size)
   else
      maxThisBuffer := findMaxSample8Bit(buffer, size);
   logToFile('Max from microphone=' + inttostr(maxThisBuffer));

   // transmit the bytes
   result := senderThread.processBytesFromMicrophone(buffer, size);

   // draw graph if required
   if showGraphs then
   begin
      inc(buffersReadIn);
      drawGraph(image1, buffersReadIn, maxThisBuffer);
   end;

end;


{called by TAudioOut when it needs some bytes to play out through the speaker}
function TForm1.AudioOutFillBuffer(Buffer: PChar; var Size: Integer): Boolean;
var
   maxThisBuffer: integer;
begin
   result := decompressionThread.getBytesForSpeaker(buffer, size);
   if size > 0 then
   begin

      // find the max sample in this buffer
      if bit16Sound then
         maxThisBuffer := findMaxSample16Bit(buffer, size)
      else
         maxThisBuffer := findMaxSample8Bit(buffer, size);

      logToFile('Max from peer=' + inttostr(maxThisBuffer));

      // and update the graph if required
      if showGraphs then
      begin
         inc(buffersReadOut);
         drawGraph(image2, buffersReadOut, maxThisBuffer);
      end;
   end;
end;


{returns the maximum sample in a buffer - this is used for drawing the graph}
function TForm1.findMaxSample16bit(Buffer: PChar; Size: Integer): integer;
var
   b: psample; // a sample is a 16 bit unsigned int
   sample: typesample;
   i, maxThisBuffer: integer;
begin
   maxThisBuffer := 0;
   b := psample(buffer); // cast buffer to a pointer to a "sample" type
   for i := 1 to Size div 2 do // each sample is a 16 bit signed int
   begin
      sample := b^;
      if sample > maxThisBuffer then maxThisBuffer := sample;
      inc(b);
   end;
   result := maxThisBuffer;
end;


{returns the maximum sample in a buffer - this is used for drawing the graph}
function TForm1.findMaxSample8bit(Buffer: PChar; Size: Integer): integer;
var
   b: pbyte; // a sample is an 8 bit unsigned int
   i, maxThisBuffer: integer;
begin
   maxThisBuffer := 0;
   b := pbyte(buffer);
   for i := 1 to Size do
   begin
      if b^ > maxThisBuffer then maxThisBuffer := b^;
      inc(b);
   end;
   result := maxThisBuffer - outputZeroSoundPressure8bit; // output zero sound pressure level is represented by 120 (says 128???) for 8-bit sounds, see TAudio.hlp
end;


{updates one of the graphs to show current volume}
procedure TForm1.drawGraph(image: TImage; x: integer; maxThisBuffer: integer);
var
   y: integer;
begin
   if x mod image.width = 0 then
   begin
     image.canvas.pen.color := clBlack;
     image.canvas.FillRect(Rect(0,0,image.width,image.height))
   end
   else if x > image.width then
   begin
      x := x mod image.width;
   end;

   if bit16Sound then
      y := (maxThisBuffer * image.Height) div 32767 // for 16 bit
   else
      y := (maxThisBuffer * image.Height) div (255-outputZeroSoundPressure8bit); // for 8 bit

   if y < 2 then y := 2; // so we always show something, even a straight line

   image.canvas.pen.color := clLime;

   image.Canvas.MoveTo(x, image.Height div 2);
   image.Canvas.LineTo(x, (image.Height div 2) - (Y div 2));

   image.Canvas.MoveTo(x, image.Height div 2);
   image.Canvas.LineTo(x, (image.Height div 2) + (Y div 2));
end;


procedure TForm1.btnConnectClick(Sender: TObject);
begin
   isServer := false;
   receivedData := '';
   sendSeq := 0;
   receiveSeq := 0;
   cleanupMemory;


   with KeyExchangeClientSocket do
   begin
      remoteHostAddress := txtRemoteHost.text;
      Host := txtRemoteHost.text;
      Port := StrToInt(txtKeyRemotePort.text);
      Open;
   end;

end;

procedure TForm1.btnListenClick(Sender: TObject);
var
   keysize: integer;
begin
   cleanupMemory;
   isServer := true;
   keysize :=  StrToInt(txtRSAKeySize.text);
   // debughook is 0 when running outside Delphi IDE
   if (not createLogFile) and (DebugHook = 0) and (keysize < 1024) then MessageDlg('Warning - key size is ' + txtRSAKeySize.text + ' which is weak, use 1024 at least!', mtWarning,[mbOk], 0);
   displayAndlogToFile('Generating ' + txtRSAKeySize.text + ' bit RSA key...please wait');
   Screen.Cursor := crHourglass;
   priv := TPrivateKey.create(keysize);
   displayAndlogToFile('Generated ' + txtRSAKeySize.text + ' bit RSA key ok');
   KeyExchangeServerSocket.Port := StrToInt(txtKeyListenPort.text);
   KeyExchangeServerSocket.active := true;
   Screen.Cursor := crDefault;
end;


procedure TForm1.KeyExchangeServerSocketAccept(Sender: TObject;
  Socket: TCustomWinSocket);
var
   pub: TPublicKey;
begin
   displayAndlogToFile('Connection from ' + Socket.RemoteAddress);
   if KeyExchangeServerSocket.socket.activeConnections > 1 then
   begin
      displayAndlogToFile('Rejecting incoming connection as already connected to ' + KeyExchangeServerSocket.socket.Connections[0].RemoteHost);
      Socket.Close;
      exit;
   end;

   connected := true;
   handshaking := true;
   Screen.Cursor := crHourglass;
   fixControls;
   intsInAESKey := 0;
   receivedData := '';
   sendSeq := 0;
   receiveSeq := 0;

   // send over our public key
   displayAndlogToFile('Sending our public key');
   pub := priv.getPublicKey();
   try

      logToFile('Sending N: ' + pub.N.asString);
      sendTextToPeer(pub.N.AsString);

      logToFile('Sending E: ' + pub.E.asString);
      sendTextToPeer(pub.E.AsString);

   finally
      pub.free;
   end;
   displayAndlogToFile('Sent public key to ' + Socket.RemoteAddress + ', receiving AES key, please wait...');
end;


procedure TForm1.KeyExchangeClientSocketConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
   connected := true;
   handShaking := true;
   fixControls;
   displayAndlogToFile('Client key exchange socket connected to ' + Socket.RemoteAddress + ':' + IntToStr(Socket.RemotePort));
end;


procedure TForm1.KeyExchangeServerSocketClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
begin
   handleReceivedText(Socket.receivetext)
end;


procedure TForm1.doClientHandshaking(textblock: string);
var
   i: integer;
   Isaac: TIsaac;
   encryptedAESKey: TStringList;
   bigint: TBigInt;
begin
   Screen.Cursor := crHourglass;

   // the first 2 lines we get from the server will be the N and E of the public key
   if N = nil then
   begin
      N := TBigInt.create(textblock);
      logToFile('Received N: ' + N.asString);
      exit;
   end;

   if E = nil then
   begin
      E := TBigInt.create(textblock);
      logToFile('Received E: ' + E.asString);

      // now we can construct the full public key
      remotePub := TPublicKey.create(E, N);
      displayAndlogToFile('Received remote RSA public key ok');
      application.processmessages;

      // now generate a random AES key
      displayAndlogToFile('Generating AES key');
      Isaac:=TIsaac.Create;
      Isaac.Seed([GetMessageTime, GetMessagePos], true);
      AESKey := '';
      for i := 1 to 256 div 8 do // FIXME long enough?
         AESKey := AESKey + chr(Isaac.val(127-32)+32);
      Isaac.Free;
      displayAndlogToFile('Generated AES key');
      logToFile('AES key:' + AESKey);
      application.processmessages;

      // encrypt this key using the remote public RSA key
      // this gives us a TStringList of TBigInt objects
      displayAndlogToFile('Encrypting AES key with remote RSA public key...please wait');
      encryptedAESKey := TStringList.create;
      remotePub.encrypt(AESKey, encryptedAESKey);

      // transmit it to our peer
      // firstly tell them how many TBigInt objects to expect
      displayAndlogToFile('Transmitting AES key');
      application.processmessages;
      logToFile('Sending size ' + inttostr(encryptedAESKey.count));
      sendTextToPeer(IntToStr(encryptedAESKey.count));

      for i := 0 to encryptedAESKey.count-1 do
      begin
       sendTextToPeer(inttostr(i)+'='+(encryptedAESKey.objects[i] as TBigInt).asString);
       logToFile('Sending AES key part ' + inttostr(i) + '=' + (encryptedAESKey.objects[i] as TBigInt).asString);
      end;

      // clean up the list
      while encryptedAESKey.count > 0 do
      begin
       bigint := (encryptedAESKey.objects[0] as TBigInt);
       encryptedAESKey.delete(0);
       bigint.free;
      end;
      encryptedAESKey.clear;
      freeAndNil(encryptedAESKey);

      displayAndlogToFile('Transmitted AES key, waiting for peer to decrypt & acknowledge');
      application.processmessages;
      exit;
   end;

   if (N <> nil) and (E <> nil) and (textBlock = ack) then
   begin
      // all done!
      handshaking := false;
      display('** HANDSHAKING COMPLETE **');
      logToFile('Client handshaking complete');
      sendCipher.InitStr(AESKey,TDCP_sha256);
      receiveCipher.InitStr(AESKey,TDCP_sha256);
      FixControls;
      if not Application.Active then flashTaskbar;
      openAudioSockets;
      Screen.Cursor := crDefault;
   end;
end;


procedure TForm1.doServerHandshaking(textblock: string);
var
   l: integer;
   index,val: string;
   bigint: TBigInt;
begin
   if intsInAESKey = 0 then
   begin
      // read number of TBigInts in RSA-encrypted AES key
      intsInAESKey := StrToInt(textblock);
      logToFile('Read AES key header, size=' + textblock);
      keyList := TStringList.create;
      keyList.sorted := true;
      intsInAESKeyReceived := 0;
   end
   else if intsInAESKeyReceived < intsInAESKey then
   begin
      // read another BigInt part of the AES key
      // parts may around out-of-sequence, so they use the format n=xxxxxxxx where n is the index
      // as keyList is sorted, using n means the parts will be re-assembled in the right order
      l := pos('=',textblock);
      index := copy(textblock,1,l-1);
      val := copy(textblock,l+1,length(textblock)-l);
      bigint := TBigInt.create(val);
      keyList.AddObject(lpad(index,8), bigint);
      logToFile('Read AES key part ' + index + '=' + bigint.asString);
      inc(intsInAESKeyReceived);

      if intsInAESKeyReceived = intsInAESKey then
      begin
         // we have the entire AES key now
         displayAndlogToFile('Received encrypted AES key...please wait whilst decrypting');
         application.processmessages;

         // decrypt the AES key with our RSA private key
         AESKey := priv.decrypt(keyList);
         displayAndlogToFile('Decrypted AES key ok');
         logToFile('AES key:' + AESKey);

         // clean up the list
         while keyList.count > 0 do
         begin
            bigint := (keyList.objects[0] as TBigInt);
            keyList.delete(0);
            bigint.free;
         end;
         keyList.clear;
         freeAndNil(keyList);

         // inform peer we've obtained & decrypted the key
         sendTextToPeer(ack);

         // all done!
         handshaking := false;
         display('** HANDSHAKING COMPLETE **');
         logToFile('Server handshaking complete');
         sendCipher.InitStr(AESKey,TDCP_sha256);
         receiveCipher.InitStr(AESKey,TDCP_sha256);
         FixControls;
         if not Application.Active then flashTaskbar;
         remoteHostAddress := KeyExchangeServerSocket.socket.Connections[0].RemoteAddress;
         openAudioSockets;
         Screen.Cursor := crDefault;
      end;
   end;
end;


procedure Tform1.handleReceivedCiphertext(ciphertext: string);
var
   plaintext:string;
begin
   // this method deals with a proper complete chunk of ciphertext that we can decrypt and process
   logToFile('Received ciphertext: ' + ciphertext);
   plaintext := decryptWithAES(ciphertext);

   displayAndlogToFile('PEER (' + TimeToStr(Now) + ') : ' + plaintext);
   if not Application.Active then flashTaskbar;
end;


procedure TForm1.flashTaskBar;
var
   FWinfo: TFlashWInfo;
begin
  FWinfo.cbSize := 20;
  FWinfo.hwnd := Application.Handle; // Handle of Window to flash
  FWinfo.dwflags := FLASHW_ALL;
  FWinfo.ucount := 2; // number of times to flash
  FWinfo.dwtimeout := 0; // speed in ms, 0 default blink cursor rate
  FlashWindowEx(FWinfo); // make it flash!
end;



procedure TForm1.sendTextToPeerEncrypted(plaintext: string);
var
   ciphertext: string;
begin
   // encrypts a block of plaintext and sends it to the peer
   displayAndlogToFile('Sending plaintext: ' + plaintext);
   ciphertext := encryptWithAES(plaintext);
   displayAndlogToFile('Sending ciphertext: ' + ciphertext);
   sendTextToPeer(ciphertext);
end;
  

procedure TForm1.sendTextToPeer(text: string);
begin
   inc(sendSeq);

   // sends some text to the peer with a chr(0) terminator
   if KeyExchangeClientSocket.active then
      KeyExchangeClientSocket.socket.SendText(inttostr(sendSeq) + char_sep + text + chr(0))
   else if KeyExchangeServerSocket.active then
      KeyExchangeServerSocket.socket.Connections[0].SendText(inttostr(sendSeq) + char_sep + text + chr(0))
   else
   begin
      //beep;
      displayAndlogToFile('Error sending text - not connected');
   end;
   if sleepDuringTransfer > 0 then
   begin
      application.processmessages;
      sleep(sleepDuringTransfer);
   end;
end;


procedure TForm1.KeyExchangeClientSocketRead(Sender: TObject;
  Socket: TCustomWinSocket);
begin
   handleReceivedText(Socket.receivetext)
end;


procedure TForm1.AudioClientSocketConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
   displayAndlogToFile('Client audio socket connected to ' + Socket.RemoteAddress + ':' + IntToStr(Socket.RemotePort));
   outputStream := TWinSocketStream.Create(AudioClientSocket.Socket, 60000);
end;


procedure TForm1.AudioClientSocketDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
   clientSocketClosing := true;
   disconnect;
   displayAndlogToFile('Disconnection on client audio socket');
   if not Application.Active then flashTaskbar;
end;


procedure TForm1.AudioClientSocketError(Sender: TObject; Socket: TCustomWinSocket;
  ErrorEvent: TErrorEvent; var ErrorCode: Integer);
begin
   disconnect;
   displayAndlogToFile('Socket error on client audio socket: ' + IntToStr(ErrorCode));
   if not Application.Active then flashTaskbar;
end;


{called when the audio client socket reads some bytes sent by the peer}
procedure TForm1.handleReceivedText(receivedText: string);
var
   textBlock: string;
   p, s, seqFromPeer: integer;
begin
   try
      // all chunks of text are terminated by chr(0), but may not always arrive in one go
      // this method deals with raw blocks of ciphertext that may be partially complete
      // or may even contain multiple chunks
      receivedData := receivedData + receivedText;

      threadLock.enter;
      try

         // take the text we have received and process it
         // more may arrive & be appended to receivedData during processing
         repeat
            p := pos(chr(0), receivedData);
            if p > 0 then
            begin
               textBlock := copy(receivedData, 1, p-1);
               receivedData := copy(receivedData, p+1, length(receivedData)-p);

               // check packet sequence
               s := pos(char_sep, textBlock);
               if s = 0 then raise exception.create('Missing sequence separator');
               inc(receiveSeq);
               seqFromPeer := strtoint(copy(textBlock, 1, s-1));
               textBlock := copy(textBlock, s+1, length(textBlock)-s);
               if seqFromPeer <> receiveSeq then
               begin
                  displayAndlogToFile(receivedData);
                  raise exception.create('Expected sequence ' + inttostr(receiveSeq) + ' but received ' + inttostr(seqFromPeer));
               end;

               if handshaking then
               begin
                  if isServer then
                     doServerHandshaking(textBlock)
                  else
                     doClientHandshaking(textBlock);
               end
               else
                  handleReceivedCiphertext(textBlock);
            end;
         until p = 0;

      finally
         threadLock.leave;
      end;

   except
      on E:Exception do
      begin
         displayAndlogToFile(E.message);
         btnDisconnect.click;
      end;
   end;
end;


procedure TForm1.KeyExchangeServerSocketListen(Sender: TObject;
  Socket: TCustomWinSocket);
begin
   displayAndlogToFile('Server key exchange socket listening on port ' + IntToStr(KeyExchangeServerSocket.port));
   connected := true;
   fixControls;
end;


procedure TForm1.AudioServerSocketAccept(Sender: TObject; Socket: TCustomWinSocket);
begin
   displayAndlogToFile('Connection on server audio socket from ' + Socket.RemoteAddress);
   if AudioServerSocket.socket.activeConnections > 1 then
   begin
      displayAndlogToFile('Rejecting incoming connection as already connected to ' + AudioServerSocket.socket.Connections[0].RemoteAddress);
      Socket.Close;
      exit;
   end;
end;


procedure TForm1.AudioServerSocketClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
   displayAndlogToFile('Server audio socket connected to ' + Socket.RemoteAddress + ':' + IntToStr(Socket.RemotePort));
end;

procedure TForm1.AudioServerSocketClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
   if socket = AudioServerSocket.socket.Connections[0] then
   begin
      serverSocketClosing := true;
      disconnect;
      displayAndlogToFile('Client disconnected from server audio socket');
      if not Application.Active then flashTaskbar;
   end;
end;


procedure TForm1.AudioServerSocketClientError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent; var ErrorCode: Integer);
begin
   disconnect;
   displayAndlogToFile('Socket error on server audio socket: ' + IntToStr(ErrorCode));
   if not Application.Active then flashTaskbar;
end;


procedure TForm1.AudioServerSocketClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
begin
   logToFile('Server audio socket received data');
   receiverThread.handleReceivedBuffer(Socket);
end;

procedure TForm1.AudioServerSocketListen(Sender: TObject; Socket: TCustomWinSocket);
begin
   displayAndlogToFile('Server audio socket listening on port ' + IntToStr(AudioServerSocket.port));
end;


procedure TForm1.KeyExchangeServerSocketClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
   if socket = KeyExchangeServerSocket.socket.Connections[0] then
   begin
      clientSocketClosing := true;
      disconnect;
      displayAndlogToFile('Client disconnected from server key exchange socket');
      if not Application.Active then flashTaskbar;
   end;
end;


procedure TForm1.KeyExchangeServerSocketClientError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
   disconnect;
   displayAndlogToFile('Socket error on server key exchange socket: ' + IntToStr(ErrorCode));
   if not Application.Active then flashTaskbar;
end;


procedure TForm1.cleanupMemory;
begin
   try
      // fixme should this be synchronized with a TCriticalSection?
      AESKey := '';
      receivedData := '';
      if priv <> nil then freeAndNil(priv);
      if remotePub <> nil then freeAndNil(remotePub);
      if keyList <> nil then freeAndNil(keyList);
      if N <> nil then freeAndNil(N);
      if E <> nil then freeAndNil(E);
   except
      on E:Exception do
         displayAndlogToFile(E.message);
   end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
   IniFile: TIniFile ;
begin
   image1.canvas.Brush.Color := clBlack;
   image1.canvas.Brush.Style := bsSolid;
   image1.canvas.FillRect(Rect(0,0,image1.width,image1.height));
   image1.canvas.pen.color := clLime;

   image2.canvas.Brush.Color := clBlack;
   image2.canvas.Brush.Style := bsSolid;
   image2.canvas.FillRect(Rect(0,0,image2.width,image2.height));
   image2.canvas.pen.color := clLime;

   AESKey := '';
   sendCipher:= TDCP_rijndael.Create(Self);
   receiveCipher:= TDCP_rijndael.Create(Self);
   connected := false;
   threadLock := TCriticalSection.create;
   FixControls;
   IniFile := TIniFile.Create(ExtractFilePath(Application.ExeName) + '\' + confFileName);
   try
      with IniFile do
      begin
         txtRsaKeySize.text := ReadString('main', 'RsaKeySize', '1024');
         showStatus := (ReadString('main', 'showStatus', 'true') = 'true');
         showGraphs := (ReadString('main', 'showGraphs', 'true') = 'true');
         panel4.Visible := showGraphs;
         panel5.Visible := showStatus;
         if fileexists(logfilename) then deletefile(logfilename);
         createLogFile := ReadString('main', 'createLogFile', 'false') = 'true';
         if createLogFile then
         begin
            assignfile(logfile, logfilename);
            rewrite(logfile);
            closefile(logfile);
         end;
         sleepDuringTransfer := ReadInteger('main', 'sleepDuringTransfer', 0);
         moveactionPath := ReadString('main', 'moveactionPath', 'moveaction.exe');
         speedButton1.down := (ReadString('main', 'antikeylogging', 'true') = 'true');
         txtKeyListenPort.text := ReadString('main', 'keyListenPort', '1801');
         txtKeyRemotePort.text := ReadString('main', 'keyRemotePort', '1801');
         txtAudioListenPort.text := ReadString('main', 'audioListenPort', '1802');
         txtAudioRemotePort.text := ReadString('main', 'audioRemotePort', '1802');
         saveHost := ReadString('main', 'saveHost', 'false') = 'true';
         if saveHost then
            txtRemoteHost.text :=  ReadString('main', 'remoteHost', '')
         else
            txtRemoteHost.text :='127.0.0.1';

         cbMode.Text := ReadString('main', 'mode', 'Transceiver');

         SpeedButton1Click(self);
      end;
   finally
     	IniFile.Free ;
   end ;

   AudioIn := TAudioIn.Create(self);
   AudioIn.BufferSize := audioBufferSize;
   AudioIn.OnBufferFilled := AudioInBufferFilled;
   if bit16Sound then
      AudioIn.Quantization := 16
   else
      AudioIn.Quantization := 8;
   AudioIn.Stereo := stereo;

   AudioOut := TAudioOut.create(self);
   AudioOut.BufferSize := audioBufferSize;
   AudioOut.OnFillBuffer := self.AudioOutFillBuffer;
   AudioOut.numBuffers := 65535; // fixme 4?
   if bit16Sound then
      AudioOut.Quantization := 16
   else
      AudioOut.Quantization := 8;
   AudioOut.Stereo := stereo;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
   if threadLock <> nil then threadLock.free;
   if sendCipher <> nil then sendCipher.Burn;
   if sendCipher <> nil then sendCipher.Free;
   if receiveCipher <> nil then receiveCipher.Burn;
   if receiveCipher <> nil then receiveCipher.Free;
   if AudioIn <> nil then AudioIn.free;
   if AudioOut <> nil then AudioOut.free;
end;

procedure TForm1.FixControls;
begin
   btnListen.enabled := (not connected);
   sbListen.enabled := (not connected);

   btnConnect.enabled := (not connected);
   sbConnect.enabled := (not connected);

   btnDisconnect.enabled := connected;
   sbDisconnect.enabled := connected;

   txtRSAKeySize.enabled := (not connected);
   txtKeyListenPort.enabled := (not connected);
   txtAudioListenPort.enabled := (not connected);
   txtRemoteHost.enabled := (not connected);
   txtKeyRemotePort.enabled := (not connected);
   txtAudioRemotePort.enabled := (not connected);

   screen.cursor := crDefault;
end;


procedure TForm1.KeyExchangeClientSocketDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
   clientSocketClosing := true;
   disconnect;
   displayAndlogToFile('Disconnection on client key exchange socket');
   if not Application.Active then flashTaskbar;
end;

procedure TForm1.KeyExchangeClientSocketError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
   disconnect;
   displayAndlogToFile('Socket error on client key exchange socket: ' + IntToStr(ErrorCode));
   if not Application.Active then flashTaskbar;
end;

procedure TForm1.btnDisconnectClick(Sender: TObject);
begin
   disconnect;
end;

function TForm1.encryptWithAES(plaintext: string): string;
begin
   result := sendCipher.EncryptString(plaintext);
end;


function TForm1.decryptWithAES(ciphertext: string): string;
begin
   result := receiveCipher.DecryptString(ciphertext);
end;    


procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
   IniFile: TIniFile;
begin
   disconnect;

   IniFile := TIniFile.Create(ExtractFilePath(Application.ExeName) + '\' + confFileName);
   try
      with IniFile do
      begin
         WriteString('main', 'RsaKeySize', txtRsaKeySize.text);
         if speedButton1.down then
            WriteString('main', 'antikeylogging','true')
         else
            WriteString('main', 'antikeylogging','false');

         WriteString('main', 'keyListenPort', txtKeyListenPort.text);
         WriteString('main', 'keyRemotePort', txtKeyRemotePort.text);

         WriteString('main', 'audioListenPort', txtAudioListenPort.text);
         WriteString('main', 'audioRemotePort', txtAudioRemotePort.text);

         if saveHost then
            WriteString('main', 'remoteHost', txtRemoteHost.text)
         else
            WriteString('main', 'remoteHost', '');

         WriteString('main', 'mode', cbMode.Text);
      end;
   finally
   	IniFile.Free ;
   end ;

	// debughook is 0 when running outside Delphi IDE
   if (DebugHook = 0) and (fileexists(logfilename)) then MessageDlg('Warning - log file left on disk!', mtWarning,[mbOk], 0);
end;

function TForm1.LPad(s: String; nLength: integer): string ;
begin
     while length(s) < nLength do
           s := '0' + s ;
     result := s ;
end ;


procedure TForm1.FormShow(Sender: TObject);
begin
   FixControls;
end;


function TForm1.genGarbageString(chars: integer):string;
var
   i: integer;
begin
   result := '';
   for i := 1 to chars do
      result := result + chr(random(255));
end;

procedure TForm1.sbLaunchMoveActionClick(Sender: TObject);
var
   c: integer;
begin
   c := ShellExecute(self.handle, 'open', pchar(moveactionPath), nil, nil, SW_SHOWNORMAL);
   if c < 32 then Application.MessageBox(pchar('Error ' + inttostr(c) + ' running ' +  moveactionPath + chr(13) + chr(10) + ' - download from http://members.lycos.co.uk/wuul ' + chr(13) + chr(10) + ' and configure path in ' + conffilename),'Error',MB_OK + MB_ICONERROR);
end;

procedure TForm1.sbVisitWebSiteClick(Sender: TObject);
begin
   ShellExecute(GetDesktopWindow, 'open', PChar('http://members.lycos.co.uk/wuul/cryptospeak/readme.html'), nil, nil, SW_ShowNormal);
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
   txtRemoteHost.AntiKeyloggingActive := speedButton1.down;
   speedButton1.Hint := 'Toggle Anti-Keylogging (currently ';
   if speedButton1.down then
      speedButton1.Hint := speedButton1.Hint + 'on)'
   else
      speedButton1.Hint := speedButton1.Hint + 'off)'
end;



procedure TForm1.stopAudio;
begin
   logToFile('Stopping audio in');
   if AudioIn.AudioActive then AudioIn.StopGracefully;

   logToFile('Stopping audio out');
   if AudioOut.AudioActive then AudioOut.StopGracefully;
end;


procedure TForm1.disconnect;
begin
   try
      if not connected then exit;

      connected := false;
      handshaking := false;

      if SenderThread <> nil then
      begin
         SenderThread.terminate;
         //SenderThread.WaitFor;
      end;
      if ReceiverThread <> nil then
      begin
         ReceiverThread.terminate;
         //ReceiverThread.WaitFor;
      end;
      if DecompressionThread <> nil then
      begin
         DecompressionThread.terminate;
         // DecompressionThread.Waitfor
      end;

      stopAudio;

      //displayAndLogToFile('Disconnecting');
      if outputStream <> nil then freeandnil(outputStream);
      if (KeyExchangeClientSocket.active) and (not clientSocketClosing) then KeyExchangeClientSocket.close;
      if (AudioClientSocket.active) and (not clientSocketClosing) then AudioClientSocket.close;
      if (KeyExchangeServerSocket.active) and (not serverSocketClosing) then
      begin
         if KeyExchangeServerSocket.socket.ActiveConnections > 0 then
            KeyExchangeServerSocket.socket.Connections[0].close;
         KeyExchangeServerSocket.Active := false;
      end;
      if (AudioServerSocket.active) and (not serverSocketClosing)  then
      begin
         if AudioServerSocket.socket.ActiveConnections > 0 then
            AudioServerSocket.socket.Connections[0].close;
         AudioServerSocket.Active := false;
      end;

      displayAndlogToFile('Disconnected');
      cleanupMemory;
      FixControls;
   except
      on E:Exception do
         logToFile(E.message); // don't show the user the annoying socket exceptions you get here
   end;
end;


{opens the sockets for sending/receiving audio - this takes place after exchanging crypto keys}
procedure TForm1.openAudioSockets;
var
   launchReceiverThread: TLaunchReceiverThread;
   launchSenderThread: TLaunchSenderThread;
begin
   buffersReadOut := 0;
   buffersReadIn := 0;

   if (cbMode.text = 'Receiver') or (cbMode.text = 'Transceiver') then // receiver
   begin
      // start listening for incoming connections
      AudioServerSocket.Port := StrToInt(txtAudioListenPort.text);
      AudioServerSocket.active := true;
      displayAndlogToFile('Audio server socket listening on port ' + inttostr(AudioServerSocket.Port));

      // we need to start AudioOut in a separate thread as it blocks
      displayAndlogToFile('Starting audio reception');
      launchReceiverThread := TLaunchReceiverThread.create(AudioOut);
      launchReceiverThread.FreeOnTerminate := True ;
      launchReceiverThread.resume;

      DecompressionThread := TDecompressionThread.create(self);
      DecompressionThread.Priority := tpTimeCritical;
      DecompressionThread.FreeOnTerminate := True ;
      DecompressionThread.resume;

      // now launch the main receiver processing threads
      ReceiverThread := TReceiverThread.create(self, receiveCipher, DecompressionThread);
      ReceiverThread.Priority := tpTimeCritical;
      ReceiverThread.FreeOnTerminate := True ;
      ReceiverThread.resume;
   end;

   if (cbMode.text = 'Transmitter') or (cbMode.text = 'Transceiver') then // transmitter
   begin
      // connect to peer
      with AudioClientSocket do
      begin
         // Host := txtRemoteHost.text;
         Address := remoteHostAddress;
         Port := StrToInt(txtAudioRemotePort.text);
         displayAndlogToFile('Audio client socket connecting to ' + remoteHostAddress + ':' + inttostr(Port));
         Open;
      end;

      // we need to start AudioIn in a separate thread as it blocks
      displayAndlogToFile('Starting audio transmission');
      launchSenderThread := TLaunchSenderThread.create(AudioIn);
      launchSenderThread.FreeOnTerminate := True ;
      launchSenderThread.resume;

      // now launch the main sender processing thread
      SenderThread := TSenderThread.create(self, outputStream, sendCipher);
      SenderThread.FreeOnTerminate := True ;
      SenderThread.resume;
   end;

   clientSocketClosing := false;
   serverSocketClosing := false;
end;


procedure TForm1.display(msg: string);
begin
   memo1.lines.add(msg);
end;


procedure TForm1.displayAndlogToFile(msg: string);
begin
   display(msg);
   logToFile(msg);
end;

end.
